'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.first = first;
exports.last = last;
exports.startCase = startCase;
exports.firstMatch = firstMatch;
exports.hasValue = hasValue;
exports.removeAfter = removeAfter;
exports.removeBefore = removeBefore;
exports.throttle = throttle;
function first(arr) {
  return arr[0];
}

function last(arr) {
  return arr.length ? arr[arr.length - 1] : null;
}

function startCase(str) {
  return str[0].toUpperCase() + str.substr(1);
}

function firstMatch(regex, str) {
  const m = regex.exec(str);
  return m ? m[0] : null;
}

function hasValue(s) {
  return s && s.length;
}

function removeAfter(delimiter, str) {
  return first(str.split(delimiter)) || '';
}

function removeBefore(delimiter, str) {
  return last(str.split(delimiter)) || '';
}

const range = exports.range = len => {
  const arr = [];
  for (let i = 0; i < len; i++) {
    arr.push(i);
  }
  return arr;
};

function throttle(callback, limit, time) {
  let calledCount = 0;
  let timeout = null;

  return function throttledFn(...args) {
    if (limit > calledCount) {
      calledCount += 1;
      callback(...args);
    }

    if (!timeout) {
      timeout = setTimeout(() => {
        calledCount = 0;
        timeout = null;
      }, time);
    }
  };
}